# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag .redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define section free
%define shortname jython

Name:           jython-eap6
Version:        2.5.2
Release:        5%{?reltag}%{?dist}.4
Epoch:          0
Summary:        Java implementation of the Python language
License:        ASL 1.1 and BSD and CNRI and JPython and Python
Group:          Development/Java
URL:            http://www.jython.org/
%if 0
svn -q export -r 7292 https://jython.svn.sourceforge.net/svnroot/jython/tags/Release_2_5_2/ jython-2.5.2 && rm -r jython-2.5.2/{htdocs,sandbox,website} && \
find jython-2.5.2/ -type f -name '*.jar' | xargs rm && tar cjf jython-2.5.2.tar.bz2 jython-2.5.2
%endif
Source0:        jython-2.5.2.tar.bz2
Source1:        jython-2.5.2.pom
Source2:        http://repo1.maven.org/maven2/org/python/jython-standalone/2.5.2/jython-standalone-2.5.2.pom
Source3:        jython.script
Source4:        jythonc.script
Patch0:         jython-build.patch
Patch1:         jython-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant >= 0:1.7
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  antlr
BuildRequires:  antlr3
BuildRequires:  jnr-constants
BuildRequires:  cpptasks
BuildRequires:  guava
BuildRequires:  jarjar
BuildRequires:  jaffl
BuildRequires:  jffi
BuildRequires:  jline
BuildRequires:  jnr-netdb
BuildRequires:  jnr-posix
BuildRequires:  junit
BuildRequires:  libreadline-java
BuildRequires:  livetribe-jsr223
BuildRequires:  mysql-connector-java
BuildRequires:  postgresql-jdbc
# XXX:
#BuildRequires:  mockrunner >= 0:0.4.1
#BuildRequires:  svnant
BuildRequires:  objectweb-asm
BuildRequires:  servlet_api
BuildRequires:  stringtemplate
BuildRequires:  xerces-j2
BuildRequires:  zip
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  jboss-parent >= 0:8
BuildArch:      noarch
Buildroot:      %{_tmppath}/%{shortname}-%{version}-%{release}-root

%description
Jython is an implementation of the high-level, dynamic, object-oriented
language Python seamlessly integrated with the Java platform. The
predecessor to Jython, JPython, is certified as 100% Pure Java. Jython is
freely available for both commercial and non-commercial use and is
distributed with source code. Jython is complementary to Java and is
especially suited for the following tasks: Embedded scripting - Java
programmers can add the Jython libraries to their system to allow end
users to write simple or complicated scripts that add functionality to the
application. Interactive experimentation - Jython provides an interactive
interpreter that can be used to interact with Java packages or with
running Java applications. This allows programmers to experiment and debug
any Java system using Jython. Rapid application development - Python
programs are typically 2-10X shorter than the equivalent Java program.
This translates directly to increased programmer productivity. The
seamless interaction between Python and Java allows developers to freely
mix the two languages both during development and in shipping products.

%package -n %{shortname}
Summary:        Java implementation of the Python language
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       antlr3
Requires:       jnr-constants
Requires:       guava
Requires:       jaffl
Requires:       jffi
Requires:       jline
Requires:       jnr-netdb
Requires:       jnr-posix
Requires:       objectweb-asm
Requires:       xerces-j2

%description -n %{shortname}
Jython is an implementation of the high-level, dynamic, object-oriented
language Python seamlessly integrated with the Java platform. The
predecessor to Jython, JPython, is certified as 100% Pure Java. Jython is
freely available for both commercial and non-commercial use and is
distributed with source code. Jython is complementary to Java and is
especially suited for the following tasks: Embedded scripting - Java
programmers can add the Jython libraries to their system to allow end
users to write simple or complicated scripts that add functionality to the
application. Interactive experimentation - Jython provides an interactive
interpreter that can be used to interact with Java packages or with
running Java applications. This allows programmers to experiment and debug
any Java system using Jython. Rapid application development - Python
programs are typically 2-10X shorter than the equivalent Java program.
This translates directly to increased programmer productivity. The
seamless interaction between Python and Java allows developers to freely
mix the two languages both during development and in shipping products.

%package -n %{shortname}-javadoc
Summary:        Javadoc for %{shortname}
Group:          Development/Java
Requires:       jpackage-utils

%description -n %{shortname}-javadoc
%{summary}.

%package -n %{shortname}-standalone
Summary:        Jython Standalone %{namedversion}
Group:          Development/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils

%description -n %{shortname}-standalone
The Jython Standalone installation is a Jython JAR also containing all Python
standard libraries. The JAR can be recreated by following the 'Standalone mode'
installation instructions:
http://wiki.python.org/jython/InstallationInstructions.

%if %with repolib
%package -n %{shortname}-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description -n %{shortname}-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{shortname}-%{version}
find -type f \( -name '*.jar' -o -name '*.class' -o -name '*.zip' \) | xargs -t rm
cp -p %{SOURCE1} jython-%{version}.pom
cp -p %{SOURCE2} jython-standalone-%{version}.pom
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1

pushd jython
ln -s $(build-classpath antlr) extlibs/antlr-2.7.7.jar
ln -s $(build-classpath antlr3) extlibs/antlr-3.1.3.jar
ln -s $(build-classpath antlr3-runtime) extlibs/antlr-runtime-3.1.3.jar
ln -s $(build-classpath objectweb-asm/asm) extlibs/asm-3.1.jar
ln -s $(build-classpath objectweb-asm/asm-commons) extlibs/asm-commons-3.1.jar
ln -s $(build-classpath objectweb-asm/asm-util) extlibs/asm-util-3.1.jar
ln -s $(build-classpath jnr-constants) extlibs/constantine.jar
ln -s $(build-classpath cpptasks) extlibs/cpptasks/cpptasks.jar
ln -s $(build-classpath guava) extlibs/guava-r07.jar
ln -s $(build-classpath jaffl) extlibs/jaffl.jar
ln -s $(build-classpath jarjar) extlibs/jarjar-0.7.jar
ln -s $(build-classpath jffi) extlibs/jffi.jar
ln -s $(build-classpath jffi-native) extlibs/jffi-native.jar
ln -s $(build-classpath jline) extlibs/jline-0.9.95-SNAPSHOT.jar
ln -s $(build-classpath livetribe-jsr223) extlibs/livetribe-jsr223.jar
ln -s $(build-classpath jnr-netdb) extlibs/jnr-netdb-0.4.jar
ln -s $(build-classpath jnr-posix) extlibs/jnr-posix.jar
ln -s $(build-classpath junit) extlibs/junit-3.8.2.jar
ln -s $(build-classpath libreadline-java) extlibs/libreadline-java-0.8.jar
ln -s $(build-classpath mysql-connector-java) extlibs/mysql-connector-java-5.1.6.jar
ln -s $(build-classpath postgresql) extlibs/postgresql-8.3-603.jdbc4.jar
ln -s $(build-classpath servlet_api) extlibs/servlet-api-2.5.jar
ln -s $(build-classpath stringtemplate) extlibs/stringtemplate-3.2.jar
ln -s $(build-classpath xercesImpl) extlibs/xercesImpl-2.9.1.jar
popd

%build
pushd jython
export CLASSPATH=`%{_bindir}/build-classpath junit`
export OPT_JAR_LIST=:
%{ant} \
       -Dbuild.sysclasspath=first \
       -Djython.base.dir=. \
       -Dwork.dir=. \
       -Dhas.repositories.connection=false \
       -Ddo.checkout=false \
       -Dinformix.present=false \
       -Doracle.present=false \
       -Djavahl.dir=. \
       -Ddo.snapshot.build=false \
  full-build
popd

%install
rm -rf %{buildroot}

# jars
%{java} -jar jython/jython_installer-%{version}.jar --silent --directory %{buildroot}%{_javadir}           --type standalone --jre %{java_home} --verbose
mv %{buildroot}%{_javadir}/jython.jar %{buildroot}%{_javadir}/%{shortname}-standalone-%{namedversion}.jar
%{java} -jar jython/jython_installer-%{version}.jar --silent --directory %{buildroot}%{_datadir}/%{shortname}   --type standard   --jre %{java_home} --verbose
perl -pi -e 's|%{buildroot}||g;' %{buildroot}%{_datadir}/%{shortname}/jython
rm %{buildroot}%{_datadir}/%{shortname}/jython
ln -s %{_bindir}/jython %{buildroot}%{_datadir}/%{shortname}/jython
rm %{buildroot}%{_datadir}/%{shortname}/bin/jython
ln -s %{_bindir}/jython %{buildroot}%{_datadir}/%{shortname}/bin/jython
rm %{buildroot}%{_datadir}/%{shortname}/jython.jar
mv jython/dist/jython-dev.jar %{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar
ln -s %{_javadir}/%{shortname}.jar %{buildroot}%{_datadir}/%{shortname}/jython.jar
pushd %{buildroot}%{_datadir}/%{shortname}/Doc
rm -r javadoc
ln -s %{_javadocdir}/%{shortname} javadoc
popd
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -sf ${jar} ${jar/-%{namedversion}/}; done)

# Alternative JAR location
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
cp -p %{buildroot}%{_javadir}/%{shortname}-standalone-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# poms
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p jython-standalone-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{shortname}-standalone.pom
%add_to_maven_depmap org.python jython-standalone %{namedversion} JPP %{shortname}-standalone
mv %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/%{shortname}-standalone
cp -p jython-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP-%{shortname}.pom
%add_to_maven_depmap org.python jython %{namedversion} JPP %{shortname}

export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp -DperformRelease=true deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{shortname}-standalone.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}-standalone-%{namedversion}.jar -DrepositoryId=jboss-releases-repository -Durl=${URL}
%{_bindir}/mvn-jpp -DperformRelease=true deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP-%{shortname}.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar -DrepositoryId=jboss-releases-repository -Durl=${URL}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
cp -pr jython/dist/Doc/javadoc/* %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
ln -s %{shortname}-%{namedversion} %{buildroot}%{_javadocdir}/%{shortname}

# scripts
mkdir -p %{buildroot}%{_bindir}
cp -p %{SOURCE3} %{buildroot}%{_bindir}/%{shortname}
cp -p %{SOURCE4} %{buildroot}%{_bindir}/%{shortname}c

%clean
rm -rf %{buildroot}

%post -n %{shortname}
%update_maven_depmap

%postun -n %{shortname}
%update_maven_depmap

%post -n %{shortname}-standalone
%update_maven_depmap

%postun -n %{shortname}-standalone
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/*jar

%files -n %{shortname}
%defattr(0644,root,root,0755)
%attr(0755,root,root) %{_bindir}/%{shortname}
%attr(0755,root,root) %{_bindir}/%{shortname}c
%{_javadir}*/%{shortname}-%{namedversion}.jar
%{_javadir}*/%{shortname}.jar
%{_mavenpomdir}/JPP-%{shortname}.pom
%{_mavendepmapfragdir}/%{name}
%defattr(-,root,root,0755)
%{_datadir}/%{shortname}

%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{namedversion}
%{_javadocdir}/%{shortname}

%files -n %{shortname}-standalone
%defattr(0644,root,root,0755)
%{_javadir}*/%{shortname}-standalone-%{namedversion}.jar
%{_javadir}*/%{shortname}-standalone.jar
%{_mavenpomdir}/JPP-%{shortname}-standalone.pom
%{_mavendepmapfragdir}/%{shortname}-standalone

%if %with repolib
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sat Sep 01 2012 Paul Gier <pgier@redhat.com> - 0:2.5.2-5.redhat_2.4
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.5.2-5.redhat_2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.5.2-5.redhat_1.2
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.5.2-5.redhat_1.1
- Rebuild using cache signing

* Fri May 04 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-5
- rename jnr-constants package

* Fri May 04 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-4
- switch from constantine to jnr-constants
- switch from jffi-complete to jffi + (empty) jffi-native

* Fri May 04 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-3
- rebuild with empty jffi-native jar (removes .so automatically)

* Thu Apr 12 2012 Martha Benitez <mbenitez@redhat.com> 0:2.5.2-2.redhat_1
- Change R: for main package to be those of jython-standalone

* Thu Apr 12 2012 Martha Benitez <mbenitez@redhat.com> 0:2.5.2-1.4_redhat_1.1
- Merge from jython
- Install jython-standalone in main package

* Wed Apr 11 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-1.4
- resolves JBPAPP-8388

* Wed Apr 11 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-1.3
- JBPAPP-8388

* Thu Apr 05 2012 Permaine Cheung <pcheung@redhat.com> - 0:2.5.2-1.2_redhat_1.2
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.5.2-1.2_redhat_1.1
- Rebuild using cache signing

* Wed Jan 18 2012 Yong Yang <yyang@redhat.com> 0:2.5.2-1.2
- Change Requires: jffi-complete to Requires: jffi

* Thu Jan 12 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-1.1
- build for redhat

* Thu Jan 12 2012 David Walluck <dwalluck@redhat.com> 0:2.5.2-1
- 2.5.2
- fix Requires based on jython jarjar
- add standalone package
- make main package the same as the standard upstream install (minus javadoc)
- drop demo and manual packages
- drop ht2html and PyXML BuildRequires

* Tue Dec 13 2011 Ralph Apel <r.apel at r-apel.de> - 0:2.5.0-2
- Promote to free

* Wed Nov 16 2011 Ralph Apel <r.apel at r-apel.de> - 0:2.5.0-1jpp
- Upgrade to 2.5.0

* Thu Jul 12 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.rc2.1jpp
- Upgrade to 2.2-rc2

* Tue Feb 27 2007 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.a0.4jpp
- Add gcj_support option
- Assure optionality of mysql-connector-java
- Reactivate ht2html BR

* Tue Jun 20 2006 Ralph Apel <r.apel at r-apel.de> - 0:2.2-0.a0.3jpp
- First JPP-1.7 release
- Oracle JDBC not required, MySQL JDBC optional

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:2.2-0.a0.2jpp
- Rebuild with ant-1.6.2
- Allow build use of python >= 2.3 to generate docs since 2.2 libraries included

* Sun Feb 15 2004 David Walluck <david@anti-microsoft.org> 0:2.2-0.a0.1jpp
- 2.2a0 (CVS)
- add URL tag
- add Distribution tag
- change cachedir patch to use ~/.jython instead of ~/tmp
- remove sys.platform patch
- use included python 2.2 files
- mysql support is back

* Fri Apr 11 2003 David Walluck <david@anti-microsoft.org> 0:2.1-5jpp
- rebuild for JPackage 1.5
- remove mm.mysql support

* Sun Jan 26 2003 David Walluck <david@anti-microsoft.org> 2.1-4jpp
- add PyXML modules from 0.8.2
- make BuildRequires a bit more strict

* Wed Jan 22 2003 David Walluck <david@anti-microsoft.org> 2.1-3jpp
- CVS 20030122
- remove javacc dependency (it's non-free, not needed, and the build is broken)
- add python modules (BuildRequires: python)
- add PyXML modules (BuildRequires: PyXML)
- add HTML documentation (BuildRequires: ht2html)
- optional JavaReadline support (BuildRequires: libreadline-java)
- optional MySQL support (BuildRequires: mm.mysql)
- optional PostgreSQL support is not available at this time due to strange jars
- add jython script
- add jythonc script
- add registry
- Patch0: fix cachedir creation in cwd
- Patch1: fix sys.platform (site.py expects format: <os.name>-<os.arch>)
- remove oro class files from jython and require the oro RPM instead
- change Url tag

* Mon Mar 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-2jpp 
- generic servlet support

* Wed Mar 06 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.1-1jpp 
- 2.1
- section macro

* Thu Jan 17 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.0-2jpp
- versioned dir for javadoc
- no dependencies for manual and javadoc packages
- stricter dependency for demo package

* Tue Dec 18 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 2.0-1jpp
- first JPackage release
